;	 ATtiny26  (c) eufs 2012 
;    www.radiokot.ru
		.include "tn26def.inc"

; 		
		.def ind1=r1
		.def ind2=r2
		.def ind3=r3
		
		.def mux=r10		;     20
		.def prizn=r11		;   
		.def schet1=r12		;   
		.def buf_adc_l=r13	;   
		.def buf_adc_h=r14
		.def buf_sreg=r15	;   
; 		
		.def temp1=r16	
		.def temp2=r17
		.def temp3=r18
		.def temp4=r19
		
		
		.def pix=r20		;    pix

;   -  
		.def buf_ind1=r21	;
		.def buf_ind2=r22
		.def buf_ind3=r23
		
		.def schet2=r24		;   
		.def n_cat=r25		;    

;=====================   ==============================

		rjmp begin			; 
	
		.org $00b			;  
		in buf_sreg,sreg	;  
		push temp1			;  
	
;		dec schet1			;  -   ( WINDOW)
;		brne indic
		dec schet2			; 
		brne indic	
		ldi schet2,128		;         
		in buf_adc_l,adcl	; 
		in buf_adc_h,adch
		clr prizn			;   

indic:
		inc n_cat			;  1  
		cpi n_cat,0			;  ?
		brne catode1
		
catode0:
		sbi portb,2			;  
		mov temp1,ind1		; 
		rcall segm			; 
		cbi portb,0			;  
		rjmp comm

catode1:
		cpi n_cat,1			;  
		brne catode2		
		sbi portb,0			;  
		mov temp1,ind2		; 
		rcall segm			; 
		cbi portb,1			;   
		rjmp comm		

catode2:
		sbi portb,1			;   
		mov temp1,ind3		;,   
		rcall segm			; 
		cbi portb,2			;  
		ser n_cat			; $FF,     
							;  1    

comm:
		pop temp1			;  
		out sreg,buf_sreg	; 
		reti


;
znak:
	.db $3f,$06,$5b,$4f,$66,$6d,$7d,$07
	.db $7f,$6f,$77,$7c,$39,$5e,$79,$71

;--------------   ------------
begin:
		ldi temp1,ramend		;  
		out sp,temp1
; 		
		ldi temp1,$07		
		out portb,temp1
		ldi temp1,$88
		out porta,temp1
		ldi temp1,$7f
		out ddrb,temp1
		ldi temp1,$74
		out ddra,temp1
		ldi temp1,$8c
; ,    		
		out admux,temp1
		ldi temp1,$fc
		out adcsr,temp1

		ldi schet2,1			; 


;   
		ldi zh,0
		ldi zl,$60
		ldi temp2,32
		clr temp1
zero:
		st z+,temp1
		st z+,temp1
		dec temp2
		brne zero

; 
		clr ind1
		clr ind2
		clr ind3
		sei				;  -  

;========   =========		
main:	sbrc prizn,0		; 
		rjmp main			;  
		ser temp1			; 
		mov prizn,temp1		
; ADMUX    20		
		sbis pina,3			
		ldi temp1,$8b
		sbic pina,3
		ldi temp1,$8c
		cp mux,temp1		
		breq main1		
		mov mux,temp1		;   - 
		out admux,temp1

main1:	
		rcall window		;  " "
		rcall hex_dec		;    
	;	rcall _12bit		;
		rjmp main			;
;===============================

; 


;   
segm:
		clr pix				;    PIX
		sbi porta,2			
		cbi porta,6
		nop
		nop
		sbic pina,7
		ori pix,1

		cbi porta,2
		sbi porta,6
		nop
		nop
		sbic pina,7
		ori pix,2

;	    
		cbi portb,3
		sbrc temp1,0
		sbi portb,3
		
		cbi portb,5
		sbrc temp1,1
		sbi portb,5

		cbi porta,2
		sbrc temp1,2
		sbi porta,2

		cbi porta,5
		sbrc temp1,3
		sbi porta,5

		cbi porta,4
		sbrc temp1,4
		sbi porta,4

		cbi portb,4
		sbrc temp1,5
		sbi portb,4

		cbi portb,6
		sbrc temp1,6
		sbi portb,6

		cbi porta,6
		sbrc temp1,7
		sbi porta,6
		ret



;       (   )
tetr:	andi temp1,$0f
		ldi zh,high(znak*2)		;   
		ldi zl,low(znak*2)
		add zl,temp1
		clr r0
		adc zh,r0
		lpm						;
		ret

;      
;    
_12bit:	push temp1
		mov temp1,temp2
		rcall tetr
		mov r3,r0
		pop temp1
		push temp1
		swap temp1
		rcall tetr
		mov r2,r0
		pop temp1
		rcall tetr
		mov r1,r0
		ret

;      
overload:
		ldi temp1,$40
		mov ind1,temp1
		mov ind2,temp1
		mov ind3,temp1
		ret

;  -
hex_dec:

;   		
		ldi temp1,low(999)		; 
		ldi temp2,high(999)
		cp temp1,buf_adc_l		;
		cpc temp2,buf_adc_h
		brcs  _999				;  999,     

		mov temp1,buf_adc_l		
		mov temp2,buf_adc_h
_999:
		clr buf_ind3			;   
hexx_1:
		mov temp3,temp1			;
		mov temp4,temp2

		subi temp1,100			; 100 ()
		sbci temp2,0	
		brcs hex_1				;      - 
		inc buf_ind3			; 1  
		rjmp hexx_1

hex_1:	mov temp1,temp3			;  
		mov temp2,temp4

		clr buf_ind2			;   
hexx_2:
		mov buf_ind1,temp1		; -     
		subi temp1,10
		brcs hex_2
		inc buf_ind2
		rjmp hexx_2

hex_2:	andi pix,$03			;  ( PIX)
		cpi pix,$03
		breq overload			; - 
		cpi pix,$0				; 
		breq no_pix				;  
		cpi pix,$01				;     
		breq xx_x
	
x_xx:							;     
		mov temp1,buf_ind3		;  
		rcall tetr				;   
		ldi temp2,$80			;  
		or r0,temp2
		mov ind3,r0				; 
		
		mov temp1,buf_ind2		; 
		rcall tetr				;
		mov ind2,r0				; 
		
		mov temp1,buf_ind1		; 
		rcall tetr				;
		mov ind1,r0				; 
		ret

;       
no_pix: 
		clr ind3				;   
		clr ind2
		cpi buf_ind3,0			;  0 
		breq hex_z1				;  -    
		mov temp1,buf_ind3
		rcall tetr
		mov ind3,r0				;    
		rjmp hex_z2
hex_z1:	
		cpi buf_ind2,0			;   0
		breq hex_z3				; 0 -   
hex_z2:
		mov temp1,buf_ind2		
		rcall tetr
		mov ind2,r0				; 

hex_z3:	mov temp1,buf_ind1
		rcall tetr
		mov ind1,r0				; 
		ret

;      		
xx_x:
		clr ind3				; 
		cpi buf_ind3,0			;     0
		breq hex_z4				; 0 -   
		mov temp1,buf_ind3
		rcall tetr
		mov ind3,r0				; 
hex_z4:
		mov temp1,buf_ind2		
		rcall tetr
		ldi temp2,$80
		or r0,temp2				;    
		mov ind2,r0
		
		mov temp1,buf_ind1
		rcall tetr
		mov ind1,r0				; 
		ret		

;      " "
window:
;      		
		ldi yl,$60	;y
		ldi yh,$0
		ldi zl,$62	;z
		ldi zh,$0

		ldi temp3,31;15
stack:
		ld temp1,z+
		ld temp2,z+
		st y+,temp1
		st y+,temp2
		dec temp3
		brne stack
;     		
		sts $9e,buf_adc_l	;  9e 7e
		sts $9f,buf_adc_h	;  9f 7f

;  ,     
		ldi yl,$60	;y
		ldi yh,$0
		ldi zh,32;16	;   
		
		clr temp1
		clr temp2
summ:
		ld temp3,y+
		add temp1,temp3
		ld temp3,y+
		adc temp2,temp3
	
		dec zh
		brne summ

;       ( )
		ldi zh,5;4
div:
		clc
		ror temp2
		ror temp1
		dec zh
		brne div
;  -   

	;	lds temp2,$61
	;	lds temp1,$60
		mov buf_adc_h,temp2
		mov buf_adc_l,temp1
		ret


